#!/usr/bin/env ruby
# encoding: utf-8

%w(lib ext test).each do |dir|
  $LOAD_PATH.unshift File.expand_path("../../#{dir}", __FILE__)
end

require 'oj'

json =<<-EOF
{
  "$id": "https://example.com/person.schema.json",
  "$schema": "https://json-schema.org/draft/2020-12/schema",
  "title": "Person",
  "type": "object",
  "properties": {
    "firstName": {
      "type": "string",
      "description": "The person's first name."
    },
    "lastName": {
      "type": "string",
      "description": "The person's last name."
    },
    "age": {
      "description": "Age in years which must be equal to or greater than zero.",
      "type": "integer",
      "minimum": 0
    }
  }
}
EOF

#json = '{"abc": true}'
#json = '[true,false]'

100_001.times do |i|
  p = Oj::Parser.new(:usual).parse(json)

  if i % 10_000 == 0
    GC.start
    rss = Integer(`ps -o rss= -p #{Process.pid}`) / 1024.0
    puts "#{i},#{rss} MB"
  end
end
